﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SearchAndSorting
{
    public partial class FormSearch : Form
    {
        //fields
        int size, minValue, maxValue;
        int[] arr;
        int pattern = 0;
        int count = 10000;
        Random rnd = new Random();
        const string NEWLINE = "\r\n";
        const string CREATE =
            "Массив создан!";
        const string FILL =
            "Массив заполнен!";
        const string CURRENT =
            "Текущеее состояние массива!";
        const string ERR_SIZE =
            "Некорректно задан размер массива" + 
            NEWLINE + "Необходимо целое число!";
        const string ERR_FILL =
            "Некорректно заданы мин. или макс. значение" +
            NEWLINE + "Необходимы целые и Min < Max!";
        const string PATTERN_IS_FOUND =
            "Образец найден" + NEWLINE +
            "Его индекс = ";
        const string PATTERN_IS_NOT_FOUND =
            "Образец не найден!";
        const string PATTERN_TO_CLASS =
            "Образец передан классу!";
        public FormSearch()
        {
            InitializeComponent();
        }

        private void buttonCreateMassiv_Click(object sender, EventArgs e)
        {
            try
            {
                size = Convert.ToInt32(textBoxSize.Text);
                arr = new int[size];
                textBoxResult.Text = CREATE;
            }
            catch (Exception)
            {
                textBoxResult.Text = ERR_SIZE;
            }

        }

        private void buttonFillRnd_Click(object sender, EventArgs e)
        {
            try
            {
                minValue = Convert.ToInt32(textBoxMinValue.Text);
                maxValue = Convert.ToInt32(textBoxMaxValue.Text);
                if (minValue > maxValue) throw (new Exception());
                //Заполнение массива случайными числами
                for (int i = 0; i < size; i++)
                    arr[i] = rnd.Next(minValue, maxValue);
                textBoxResult.Text = FILL;
            }
            catch (Exception)
            {
                textBoxResult.Text = ERR_FILL;
            }
        }

        private void buttonCurrentState_Click(object sender, EventArgs e)
        {
            listBoxMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxMassiv.Items.Add(arr[i]);
            textBoxResult.Text = CURRENT;
        }

        private void buttonLinSearch_Click(object sender, EventArgs e)
        {
            int result;
            result = Service<int>.SearchPattern(arr, pattern);
            if (result != -1)
                textBoxResult.Text = PATTERN_IS_FOUND + result;
            else
                textBoxResult.Text = PATTERN_IS_NOT_FOUND;

        }

        private void buttonPattern_Click(object sender, EventArgs e)
        {
            pattern = Convert.ToInt32(textBoxPattern.Text);
            count = Convert.ToInt32(textBoxCount.Text);
            textBoxResult.Text = PATTERN_TO_CLASS;
        }

        private void buttonTimeLinear_Click(object sender, EventArgs e)
        {
            textBoxTimeLinSearch.Text = Service<int>.HowLong
                (Service<int>.SearchPattern, count, arr, pattern).ToString();
        }

        private void buttonBarierSearch_Click(object sender, EventArgs e)
        {
            int n = arr.Length - 1;
            arr[n] = pattern; //барьер
            int result;
            result = Service<int>.SearchBarrier(arr, pattern);
            if (result != n)
                textBoxResult.Text = PATTERN_IS_FOUND + result;
            else
                textBoxResult.Text = PATTERN_IS_NOT_FOUND;
        }

        private void buttonTimeBarier_Click(object sender, EventArgs e)
        {
            textBoxTimeBarier.Text = Service<int>.HowLong
                (Service<int>.SearchBarrier, count, arr, pattern).ToString();

        }

        private void buttonSort_Click(object sender, EventArgs e)
        {
            Array.Sort(arr);
        }

        private void buttonBinSearchTime_Click(object sender, EventArgs e)
        {
            textBoxTimeBinSearch.Text = Service<int>.HowLong
                (Service<int>.BinSearch, count, arr, pattern).ToString();
        }

        private void buttonBinarySearch_Click(object sender, EventArgs e)
        {
            int result;
            result = Service<int>.BinSearch(arr, pattern);
            if (result != -1)
                textBoxResult.Text = PATTERN_IS_FOUND + result;
            else
                textBoxResult.Text = PATTERN_IS_NOT_FOUND;

        }
    }
}
