﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SearchAndSorting
{
    public partial class FormSorting : Form
    {
        //fields
        int size, minValue, maxValue;
        int[] arr;
        int[] sortArr;
        int count = 1000;
        Random rnd = new Random();
        const string NEWLINE = "\r\n";
        const string CREATE =
            "Массив создан!";
        const string FILL =
            "Массив заполнен!";
        const string SORTED =
            "Массив отсортирован!";
        const string CURRENT =
            "Текущеее состояние массива!";
        const string ERR_SIZE =
            "Некорректно задан размер массива" +
            NEWLINE + "Необходимо целое число!";
        const string ERR_FILL =
            "Некорректно заданы мин. или макс. значение" +
            NEWLINE + "Необходимы целые и Min < Max!";
        public FormSorting()
        {
            InitializeComponent();
        }

        private void buttonCreateMassiv_Click(object sender, EventArgs e)
        {
            try
            {
                size = Convert.ToInt32(textBoxSize.Text);
                arr = new int[size];
                sortArr = new int[size];
                textBoxResult.Text = CREATE;
            }
            catch (Exception)
            {
                textBoxResult.Text = ERR_SIZE;
            }

        }

        private void buttonFillRnd_Click(object sender, EventArgs e)
        {
            try
            {
                minValue = Convert.ToInt32(textBoxMinValue.Text);
                maxValue = Convert.ToInt32(textBoxMaxValue.Text);
                if (minValue > maxValue) throw (new Exception());
                //Заполнение массива случайными числами
                for (int i = 0; i < size; i++)
                    arr[i] = rnd.Next(minValue, maxValue);
                textBoxResult.Text = FILL;
            }
            catch (Exception)
            {
                textBoxResult.Text = ERR_FILL;
            }
        }

        private void buttonCurrentState_Click(object sender, EventArgs e)
        {
            listBoxMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxMassiv.Items.Add(arr[i]);
            textBoxResult.Text = CURRENT;
        }

        private void buttonQuickSort_Click(object sender, EventArgs e)
        {           
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.QuickSort(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;

        }

        private void buttonTimeQuickSort_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text);
            textBoxTimeQuickSort.Text = "";
            textBoxTimeQuickSort.Text = SortService<int>.HowLong
               (SortService<int>.QuickSort, count, arr).ToString();
            
        }

        private void buttonPyramidSort_Click(object sender, EventArgs e)
        {
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.PyramidSort(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;

        }

        private void buttonTimePyramid_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text);
            textBoxTimePyramid.Text = SortService<int>.HowLong
                           (SortService<int>.PyramidSort, count, arr).ToString();
        }

        private void buttonMergeSort_Click(object sender, EventArgs e)
        {
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.SortMerge(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;

        }

        private void buttonTimeMergeSort_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text); 
            textBoxTimeMerge.Text = SortService<int>.HowLong
              (SortService<int>.SortMerge, count, arr).ToString();

        }

        private void buttonShellSort_Click(object sender, EventArgs e)
        {
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.ShellSort(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;

        }

        private void buttonTimeShellSort_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text); 
            textBoxTimeShell.Text = SortService<int>.HowLong
                 (SortService<int>.ShellSort, count, arr).ToString();


        }

        private void buttonBubbleSort_Click(object sender, EventArgs e)
        {
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.BubbleSort(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;

        }

        private void buttonTimeBubbleSort_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text); 
            textBoxTimeBubble.Text = SortService<int>.HowLong
                 (SortService<int>.BubbleSort, count, arr).ToString();


        }

        private void buttonInsertSort_Click(object sender, EventArgs e)
        {
            Array.Copy(arr, sortArr, arr.Length);
            SortService<int>.InsertSort(sortArr);
            listBoxSortMassiv.Items.Clear();
            for (int i = 0; i < size; i++)
                listBoxSortMassiv.Items.Add(sortArr[i]);
            textBoxResult.Text = SORTED;


        }

        private void buttonTimeInsertSort_Click(object sender, EventArgs e)
        {
            count = int.Parse(textBoxCount.Text);
            textBoxTimeInsert.Text = SortService<int>.HowLong
                 (SortService<int>.InsertSort, count, arr).ToString();

        }
    }
}
